#include <Servo.h>
Servo myservo;  // create servo object to control a servo
int pos = 0;    // variable to store the servo position

char state = '1'; // initial state of deterministic finite automaton
const int ledPinRed = 13;
const int ledPinGreen = 12;
const int pirPIN = A0;
const int button = 4;
const int servoPin = 5;
int OK = 1;

void setup() {
  
  Serial.begin(9600);
  pinMode(ledPinRed, OUTPUT);
  pinMode(ledPinGreen, OUTPUT);
  pinMode(pirPIN, INPUT);
  pinMode(button, INPUT);
  myservo.attach(servoPin);  // attaches the servo on pin 5 to the servo object
}

void loop() {
  int pirStatus = digitalRead(pirPIN); // input from PIR sensor
  int buttonState = digitalRead(button);
  Serial.println(buttonState);
 
  if (buttonState == 0) {
    if (pirStatus == 1)
    {
      Serial.println(pirStatus);
      if (state == '1') { // if closed and receive 1 goes to state 2(the opened state)
        state = '2';
      }
    }
    else {
      if (state == '3') { // // if opened and receive 0 goes to state 4
        state = '4';
      }
    }
    if (state == '2') { // in state 2, the engine open the trash
      Serial.print("Turn up the engine:");
      digitalWrite(ledPinRed, HIGH);
      digitalWrite(ledPinGreen, LOW);
      for (pos = 90; pos >= 1; pos -= 1) {
        myservo.write(pos);
        delay(15);
      }
      delay(5000);
      state = '3'; // goes to state 3(wait for the input to stop to return and go to state 4)
    }
    if (state == '4') { // closes the trash and goes to initial state
      Serial.print("Turn down the engine:");
      digitalWrite(ledPinRed, LOW);
      digitalWrite(ledPinGreen, HIGH);
      for (pos = 0; pos <= 90; pos += 1) {
        myservo.write(pos);
        delay(15);
      }
      state = '1';
    }
  }
}
